#-*- coding:utf-8 -*-
# PyWakeUpSP.py
# Copyright (c) 2008-2013 masa 
# version = 0.02(5)

"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

#  Change this part According to your environment
ini_file = u'E:\\python\\PyWakeUpSP.ini'
log_file = u'E:\\Data\\WakeUp.log'
wakeup_music = 'E:\\Sounds\\Simple\\Bach.aac' # use this when can't open ini\file
play_all = 1 # 1:play music until music_end 0:cut after play_time seconds
play_time = 60 ## sec
RP = 1 # global loop control
volume_lebel = 4
fade_out = 0 # fade out control flag
#  /end

# *1
import sys
sys.setdefaultencoding('utf-8')

import e32
import audio
import random
import os

script_lock = e32.Ao_lock()
timer = e32.Ao_timer()

def cb(prev, curr, err):
  global RP
  global fade_out
  if curr == 1: 
    RP = 0
    fade_out = 0
    script_lock.signal()

def cbbchk():
  global RP
  if not os.path.exists(log_file):
    RP = 0 # loop flg off,go to end
  else:
    pass
  script_lock.signal()

if not os.path.exists(log_file):
  f = open(log_file, 'w')
  f.close()

try :
	f = open(ini_file,'r')
	fData = f.read()
	f.close()

except :
	fData = wakeup_music

musics = fData.split("\n")


#	*1
#MUSIC = musics[random.randint(0, (len(musics) - 1))]
#MUSIC = unicode(musics[random.randint(0, (len(musics) - 1))],'japanese.shift_jis')
MUSIC = unicode(musics[random.randint(0, (len(musics) - 1))],'utf-8')


S = audio.Sound.open(MUSIC)
S.set_volume(volume_lebel)


if play_all == 1:
  S.play(1, 0, cb)
  while RP == 1:
    timer.after(5,cbbchk)
    script_lock.wait()

else:
  S.play(1, 0, cb)
  pcount = int(play_time / 5) # play pcount*5 sec
  while RP == 1:
    pcount = pcount -1
    if pcount < 1:
      RP = 0
      fade_out = 1
    timer.after(5,cbbchk)
    script_lock.wait()

#volume down process V0.2(5)
if fade_out:
  while volume_lebel:
    volume_lebel = volume_lebel - 1
    S.set_volume(volume_lebel)
    timer.after(1.3 ,cbbchk)
    script_lock.wait()
S.stop()

